/*
 * NotovaOsnova.java
 *
 * Created on 23. erven 2007, 13:57
 *
 */

package notovyeditor;

import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Image;
import java.awt.Toolkit;
import java.awt.image.ImageObserver;
import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Hashtable;
import javax.imageio.ImageIO;
import javax.swing.JOptionPane;

/**
 *
 * @author Z32
 */
public class NotovaOsnova extends javax.swing.JFrame{
    //definice konstatnt
    final int POCET_LINEK = 5;
    final int VYNECHANE_MISTO = 100;
    final int ROZPETI_RADEK = 14;
    final int MEZERA_MEZI_TONY = ROZPETI_RADEK /2;
    final int NEJNIZSI_RADKA = VYNECHANE_MISTO +  5*14;
    final int POMLKA = VYNECHANE_MISTO + 2*ROZPETI_RADEK;
    final int SIRKA_NOTY = 45;
    final int SIRKA_ZAHLAVI = 60;
    final String OBRAZKY_DIR = "./images/";
    
    //definice promnnch
    String takt;
    int intTakt;
    Hashtable<String, Integer> vyska = new Hashtable<String, Integer>();
    ArrayList<String> nots;
    Image klic,taktImage;
    //definice ImageObserveru vyuivajcho metodu imageUpdate pedka tto tdy (javax.swing.JFrame)
    ImageObserver imageObserver = new ImageObserver() {
        public boolean imageUpdate(Image img, int infoflags, int x, int y, int width, int height) {
            return imageUpdate(img,infoflags,x,y,width,height);
        }
    };
    
    /** Konstruktor nov instance NotovaOsnova */
    public NotovaOsnova(String length, ArrayList<String> nots) {
        this.nots = nots;
        this.takt = length.trim().split("/")[0].trim();
        this.intTakt = Integer.parseInt(takt);
        setSize(SIRKA_ZAHLAVI+nots.size()*SIRKA_NOTY, NEJNIZSI_RADKA+VYNECHANE_MISTO);
        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        Dimension d =  Toolkit.getDefaultToolkit().getScreenSize();
        int x = (int)Math.round((d.getWidth() - getWidth())/2);
        int y = (int)Math.round((d.getHeight() - getHeight()) /2);
        setLocation(x,y);
        setTitle("Noty");
        initVariables();
        /** Existuje zde problm z reloadem (z pekreslenm) okna */
    }
    
    /** Inicializace promnnch*/
    private void initVariables() {
        //inicializace promnnch definujcch y souadnici tnu
        vyska.put("C",new Integer(NEJNIZSI_RADKA+MEZERA_MEZI_TONY));
        vyska.put("D",new Integer(NEJNIZSI_RADKA));
        vyska.put("E",new Integer(NEJNIZSI_RADKA-MEZERA_MEZI_TONY));
        vyska.put("F",new Integer(NEJNIZSI_RADKA-2*MEZERA_MEZI_TONY));
        vyska.put("G",new Integer(NEJNIZSI_RADKA-3*MEZERA_MEZI_TONY));
        vyska.put("A",new Integer(NEJNIZSI_RADKA-4*MEZERA_MEZI_TONY));
        vyska.put("H",new Integer(NEJNIZSI_RADKA-5*MEZERA_MEZI_TONY));
        vyska.put("c",new Integer(NEJNIZSI_RADKA-6*MEZERA_MEZI_TONY));
        vyska.put("d",new Integer(NEJNIZSI_RADKA-7*MEZERA_MEZI_TONY));
        vyska.put("e",new Integer(NEJNIZSI_RADKA-8*MEZERA_MEZI_TONY));
        vyska.put("f",new Integer(NEJNIZSI_RADKA-9*MEZERA_MEZI_TONY));
        vyska.put("g",new Integer(NEJNIZSI_RADKA-10*MEZERA_MEZI_TONY));
        vyska.put("a",new Integer(NEJNIZSI_RADKA-11*MEZERA_MEZI_TONY));
        vyska.put("h",new Integer(NEJNIZSI_RADKA-12*MEZERA_MEZI_TONY));
        //definice pomlky
        vyska.put("pomlka",POMLKA);
        
        //definice obrzku klic a taktImage
        try {
            klic = (Image)ImageIO.read(new File(OBRAZKY_DIR+"klic.png"));
            taktImage = (Image)ImageIO.read(new File(OBRAZKY_DIR+"takt_"+takt+".png"));
        } catch (IOException ioe) {
            JOptionPane.showMessageDialog(this, "Chyba pi natn obrzk", "Chyba", JOptionPane.ERROR_MESSAGE);
            System.exit(1);
        }
        
    }
    
    /** Natn obrzk podle zadanho jmno ze sloky s obrzky*/
    private Image getImage(String name) {
        try {
            return (Image)ImageIO.read(new File(OBRAZKY_DIR+name));
        } catch (IOException ex) {
            JOptionPane.showMessageDialog(this, "Chyba pi natn obrzk", "Chyba", JOptionPane.ERROR_MESSAGE);
            System.exit(1);
            return null;
        }
    }
    
    /** Vrac smr noiky noty*/
    private String getSmerNozicky(String nota) {
        if (nota.startsWith("C") || nota.startsWith("C") || nota.startsWith("D") || nota.startsWith("E")
        || nota.startsWith("E") || nota.startsWith("F") || nota.startsWith("G")
        || nota.startsWith("A") || nota.startsWith("H")) {
            return "nahoru";
        }
        return "dolu";
    }
    
    /** Vykresluje formul*/
    public void paint(Graphics g){
        //voln metody pedka
        super.paint(g);
        
        //vytvoen notovch linek
        int delka = SIRKA_ZAHLAVI + SIRKA_NOTY*(nots.size());
        for (int i=0;i<POCET_LINEK;i++) {
            g.drawLine(0,VYNECHANE_MISTO+(14*i),delka,VYNECHANE_MISTO+(14*i));
        }
        
        // nakreslen notovho kle a oznaen taktu
        g.drawImage(klic,0,VYNECHANE_MISTO,imageObserver);
        g.drawImage(taktImage,40,VYNECHANE_MISTO,imageObserver);
        
        /*** kreslen samotnch not **/
        //defince pomocnch promnnch
        String [] rozdelenaRadka;
        String krizek="", smer="";
        int korekceVysky = 45;
        float aktualniVelikostTaktu = 0;
        Image img;
        char hodnotaNoty;
        
        //cyklus pro vykreslovn not
        for (int i=0;i<nots.size();i++){
            //rozdlen dky souboru podle mezery
            rozdelenaRadka = nots.get(i).toString().trim().split(" ");
            
            //testovn o jak typ noty se jedn a nsledn sloen nzvu obrzku
            //a vrcen intance objektu Image do promnn img
            if (rozdelenaRadka[0].equals("pomlka")) {
                if (!rozdelenaRadka[1].equals("3")) {
                    hodnotaNoty = rozdelenaRadka[1].charAt(0);
                } else
                    hodnotaNoty = '2';
                img = getImage("pomlka_"+hodnotaNoty+".png");
                korekceVysky = 0;
            } else {
                if (rozdelenaRadka[0].endsWith("is"))
                    krizek = "krizek_";
                if (!rozdelenaRadka[1].equals("4"))
                    smer = getSmerNozicky(rozdelenaRadka[0]) + "_";
                else
                    korekceVysky = 0;
                if (!rozdelenaRadka[1].equals("3")) {
                    hodnotaNoty = rozdelenaRadka[1].charAt(0);
                } else
                    hodnotaNoty = '2';
                img = getImage("nota_"+krizek+smer+hodnotaNoty+".png");
            }
            
            //vykreslen samotnho obrzku
            g.drawImage(img,SIRKA_ZAHLAVI+SIRKA_NOTY*i,vyska.get(rozdelenaRadka[0])-korekceVysky,imageObserver);
            aktualniVelikostTaktu+= Float.parseFloat(rozdelenaRadka[1]); //zven velikosti taktu pro pozdj testovn zda ji neni poteba nov takotv ry
            //testovn aktualn velikosti taktu a ppadn vykreslen taktov ry
            if (aktualniVelikostTaktu == intTakt){
                g.drawLine(SIRKA_ZAHLAVI+SIRKA_NOTY*(i+1), VYNECHANE_MISTO, SIRKA_ZAHLAVI+SIRKA_NOTY*(i+1), NEJNIZSI_RADKA-ROZPETI_RADEK);
                aktualniVelikostTaktu = 0;
            }
            
            //vrcen pomocnch promnnch na pvodn hodnoty pro dal prhod cyklu
            krizek = "";
            smer = "";
            korekceVysky = 45;
        }
    }
    
}
